;------------------------------------------------------------------------------
; KC-85-RAM-Forth, Erweiterung FORTH-EX (Diskettenworte)
; FIG-FORTH basierend, Version 1.2
;------------------------------------------------------------------------------
; File Name   :	h:\hobby\hobby0\kc85 forth\FORTHEX.rom
; Base Address:	0000h Range: 0200h - 0780h Loaded length: 0580h
;
; assemblieren mit macro assembler as 1.42 Beta [Bld 82] oder neuer !!
;
; reass. V.Pohlers 10.2012, KC85-spezifisches M. Leubner
; letzte -nderung: 31.10.2012 19:04:39
;------------------------------------------------------------------------------

		cpu	z80undoc

;------------------------------------------------------------------------------
;	KC85-Vereinbarungen

PIO_A		equ	88H		; PIO Port A
					; Bit 5 = LED
					; Bit 6 = Kassettenrecorder (Motorschaltspannung)

INTAB		equ	0B7BBH		; Zeiger auf Eingabekanal

PV1		equ	0F003H		; CAOS-Programmverteiler I   (DB UP-Nr.)
LOOPP		equ	12h		; Einsprung zu CAOS-Menueschleife
OSTR		equ	23h		; Zeichenkette anzeigen
MODU		equ	26h		; Modulsteuerung

;------------------------------------------------------------------------------
; Makro fr FORTH-Header
; Aufruf:	header	EXEC,"EXECUTE"				( primitive )
;		header	COLON,":",DOCOL,IMMEDIATE		( Colon-Definition )

edlnk0		eval	0					; erste LFA

header		MACRO	LABL,NAME, CFA, HBITS, LFA, {NoExpand}
onlnk0		eval	$
		if "HBITS"<>""
			db	80h | StrLen(NAME) | HBITS
		else
			db	80h | StrLen(NAME)
		endif
		if StrLen(NAME)>1
			db	SubStr(NAME,0,StrLen(NAME)-1)
		endif
		db	charfromstr(NAME,StrLen(NAME)-1) | 80h
		; LFA
		if "LFA"<>""
			dw	LFA
		else
			dw	edlnk0
		endif
edlnk0		eval 	onlnk0
		; CFA
LABL		label	$
		if "CFA"<>""
			dw	CFA
		else
			dw	$+2	; primitive
		endif
		
		shared LABL
		ENDM
		
IMMEDIATE	equ	1<<6		; Immediate-Bit
;------------------------------------------------------------------------------

		include	FORTH-m026.inc


; jetzt geht es los
;------------------------------------------------------------------------------
; User-Area
		org 200h

		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		dw 0E0h                	; 6 INIT (S0)      
		dw 17Eh                	; 8 INIT (R0)      
		dw 0E0h                	; 10 INIT (TIB)    
		dw 1Fh                 	; 12 INIT (WIDTH)  
		dw 0                   	; 14 INIT (WARNING)
		dw unk_28D     		; 16 INIT (FENCE)           
		dw unk_6A2              ; 18 INIT (DP)              
		dw off_028B             ; 20 INIT (VOC-LINK)        
		dw 2FF0h                ; 22 INIT (FIRST)           
		dw 4000h                ; 24 INIT (LIMIT)           
		dw 0400h                ; 26 INIT (IOTAB)           
		dw 0                    ; Initialisierung OFFSET    
;
		db    0
		db    0
		db    3
		db    0
		db  4Dh	; M
		db  54h	; T
		db    6
		db    0
		db  76h	; v
		db    2
		db  76h	; v
		db    2
		db    0
		db    0
		db  10h
		db    0
		db 0FFh
		db 0FFh
		db    0
		db    0
		db 0DEh	; 
		db    0
		db    0
		db    0
		db 0E1h	; 
		db    6
		db 0FFh
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
;
off_248:	dw 0FDFCh


		;org	24Ah

; ab 24Ah Worte im RAM
; diese mssen genau so angelegt sein wie in FORTH-m026.asm

;IRM_ON		equ	024Ah
;IRM_OFF	equ	0251h
;PABOR		equ	0262h
;FORTH		equ	0270h
;EDITOR		equ	0283h
;INITDP

;------------------------------------------------------------------------------
IRM_ON:		in	a, (PIO_A)
		set	2, a
		out	(PIO_A), a
		ret
;------------------------------------------------------------------------------
IRM_OFF:	in	a, (PIO_A)
		res	2, a
		out	(PIO_A), a
		ret
;------------------------------------------------------------------------------
; (ABORT)
		header	ePABOR,"(ABORT)",DOCOL,,COLD_

		dw	ABORT
		dw	SEMIS
;------------------------------------------------------------------------------
; FORTH
FORTH_		header	eFORTH,"FORTH",DODOE,IMMEDIATE

		dw	DOVOC
off_0274	dw	0A081h
		dw	DLOAD_	; TASK_
off_0278	dw	0
;------------------------------------------------------------------------------
; EDITOR
EDITOR_		header	eEDITOR,"EDITOR",DODOE,IMMEDIATE

		dw	DOVOC
		dw	0A081h
		dw	EDIT_
off_028B	dw	off_0278

INITDP		equ	$

;------------------------------------------------------------------------------
; busIN (adr -> b )
;
; Einleseoperation vom 16 Bit E/A-Port adr, bergibt die Daten b
; (siehe BUSIN in FORTH).

unk_28D		header	busIND,"busIN",,,TASK_

		exx
		pop	hl
		ld	b, h
		ld	c, l
		in	a, (c)
		exx
		ld	l, a
		ld	h, 0
		push	hl
		jp	NEXT

;------------------------------------------------------------------------------
; busOUT (b adr -> )
;
; Ausgabeoperation des Bytes b an den 16 Bit E/A-Port adr (siehe
; BUSOUT).

		header	busOUTD,"busOUT"

		exx
		pop	hl
		pop	de
		ld	b, h
		ld	c, l
		out	(c), e
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; drw (b1 -> b2 )
;
; bergabe des Steuerbytes b1 an das Diskettenerweiterungsprogramm
; (DEP). Nach Ausfhren der Operation wird das Antwortbyte b2
; bergeben.

		header	drw,"drw",DOCOL

		dw LIT
		dw 80F3h
		dw busOUTD
		dw LIT
		dw 80F3h
		dw busIND
		dw ONE
		dw ANDD
		dw ZEQU
		dw ZBRAN
		dw 0FFF2h
		dw LIT
		dw 80F3h
		dw busIND
		dw DUPP
		dw LIT
		dw 80h
		dw ANDD
		dw ZBRAN
		dw 24h
		dw BASE
		dw AT
		dw HEX
		dw CR
		dw LIT
		dw 81F3h
		dw busIND
		dw LIT
		dw 4
		dw DOTR
		dw BASE
		dw STORE
		dw TWO
		dw SPACS
		dw LIT
		dw 0Ch
		dw ERROR
		dw SEMIS

;------------------------------------------------------------------------------
; ioa (b -> adr )
;
; Berechnung der I/O-Adresse des bergabepuffers zum DEP aus der
; Position b.

		header	ioa,"ioa",DOCOL

		dw LIT
		dw 128
		dw PLUS
		dw LIT
		dw 256
		dw STAR
		dw LIT
		dw 242
		dw PLUS
		dw SEMIS

;------------------------------------------------------------------------------
; m>b (adr1 -> adr2 )
;
; Transport von 128 Bytes aus dem Speicher, ab Adresse adr1, in den
; I/O-Puffer B von DEP (Datenpuffer) (adr2 = adr1 + 128).

		header	mtob,"m>b",DOCOL

		dw LIT
		dw 128
		dw ZERO
		dw XDO
		dw DUPP
		dw CAT
		dw IDO
		dw ioa
		dw busOUTD
		dw ONEP
		dw XLOOP
		dw 0FFF2h
		dw SEMIS

;------------------------------------------------------------------------------
; b>m (adr1 -> adr2 )
;
; Transport des Inhaltes vom I/O-Puffer B von DEP (Datenpuffer) in
; den Speicher, ab Adresse adr1 (adr2 = adr1 + 128).

		header	btom,"b>m",DOCOL

		dw LIT
		dw 128
		dw ZERO
		dw XDO
		dw DUPP
		dw IDO
		dw ioa
		dw busIND
		dw SWAP
		dw CSTOR
		dw ONEP
		dw XLOOP
		dw 0FFF0h
		dw SEMIS

;------------------------------------------------------------------------------
; swr (b1 b2 b3 b4 n -> )
;
; Der Screen n wird auf Diskette geschrieben (b1 ... b4 sind Steuerbytes
; fr DEP).

		header	swr,"swr",DOCOL

		dw BLOCK
		dw LIT
		dw 4
		dw ZERO
		dw XDO
		dw mtob
		dw SWAP
		dw drw
		dw DROP
		dw XLOOP
		dw 0FFF6h
		dw DROP
		dw SEMIS

;------------------------------------------------------------------------------
; srd (b1 ... bz n z -> )
;
; z Blcke des Screens n werden von der Diskette gelesen
; (z= 1,...4, bi sind die erforderlichen Steuerzeichen von DEP fr
; jeden Block).

		header	srd,"srd",DOCOL

		dw ZERO
		dw XDO
		dw SWAP
		dw drw
		dw DROP
		dw btom
		dw XLOOP
		dw 0FFF6h
		dw DROP
		dw SEMIS

;------------------------------------------------------------------------------
; n>a (adr n -> )
;
; Transport von n Bytes, ab Adresse adr in den I/O-Puffer A von DEP
; (Namens- und Mitteilungspuffer).

		header	ntoa,"n>a",DOCOL

		dw ZERO
		dw XDO
		dw DUPP
		dw CAT
		dw IDO
		dw LIT
		dw 130
		dw PLUS
		dw LIT
		dw 256
		dw STAR
		dw LIT
		dw 243
		dw PLUS
		dw busOUTD
		dw ONEP
		dw XLOOP
		dw 0FFE2h
		dw DROP
		dw SEMIS

;------------------------------------------------------------------------------
; f>a ( -> )
;
; Acht Zeichen des nach f>a im aktuellen Eingabepuffer folgenden
; Wortes, an die die Zeichenkette ".(F)" angehangen wird, werden in
; den I/O-Puffer A von DEP (Namens- und Mitteilungspuffer) transportiert.

		header	ftoa,"f>a",DOCOL

		dw LIT
		dw 20h
		dw WORD
		dw HERE
		dw DUPP
		dw CAT
		dw ONEP
		dw DUPP
		dw ROT
		dw PLUS
		dw SWAP
		dw LIT
		dw 0Ah
		dw SWAP
		dw SUBB
		dw ZERO
		dw XDO
		dw LIT
		dw 20h
		dw OVER
		dw CSTOR
		dw ONEP
		dw XLOOP
		dw 0FFF4h
		dw DROP
		dw HERE
		dw LIT
		dw 9
		dw PLUS
		dw LIT
		dw 282Eh
		dw OVER
		dw STORE
		dw TWO
		dw PLUS
		dw LIT
		dw 2946h
		dw SWAP
		dw STORE
		dw HERE
		dw ONEP
		dw LIT
		dw 0Ch
		dw ntoa
		dw SEMIS

;------------------------------------------------------------------------------
; w>a ( -> )
;
; 12 Zeichen des nach w>a im aktuellen Eingabepuffer folgenden
; Worts werden in den I/O-Puffer A von DEP (Namens- und Mitteilungspuffer)
; transportiert.

		header	wtoa,"w>a",DOCOL

		dw LIT
		dw 20h
		dw WORD
		dw HERE
		dw COUNT
		dw ntoa
		dw SEMIS

;------------------------------------------------------------------------------
; a>d (b -> )
;
; b Zeichen des I/O-Puffers A von DEP werden auf dem Bildschirm
; dargestellt.

		header	atod,"a>d",DOCOL

		dw ZERO
		dw XDO
		dw IDO
		dw LIT
		dw 82h
		dw PLUS
		dw LIT
		dw 100h
		dw STAR
		dw LIT
		dw 0F3h
		dw PLUS
		dw busIND
		dw EMIT
		dw XLOOP
		dw 0FFE6h
		dw SEMIS

;------------------------------------------------------------------------------
; DIR ( -> )
;
; Der Inhalt der Diskette wird auf dem Bildschirm angezeigt.
; Folgende Hilfsworte sind ebenfalls im Vokabular enthalten:

		header	DIR,"DIR",DOCOL

		dw CR
		dw LIT
		dw 0Dh
		dw drw
		dw LIT
		dw 26h
		dw atod
		dw LIT
		dw 4
		dw SUBB
		dw ZBRAN
		dw 1Ch
		dw LIT
		dw 5
		dw drw
		dw LIT
		dw 4
		dw SUBB
		dw ZBRAN
		dw 0Ch
		dw LIT
		dw 26h
		dw atod
		dw BRAN
		dw 0FFE8h
		dw SEMIS

;------------------------------------------------------------------------------
; STAT ( -> )
;
; Der frei Speicherbereich auf der Diskette wird auf dem Bildschirm
; ausgegeben.

		header	STAT,"STAT",DOCOL

		dw LIT
		dw 15h
		dw drw
		dw LIT
		dw 14h
		dw atod
		dw DROP
		dw SEMIS

;------------------------------------------------------------------------------
; SETRO name ( -> )
;
; Setzen des Dateiattributes RO (read only) fr die Diskettendatei
; "name". Der Name darf maximal acht Zeichen lang sein. Der
; Dateityp ist, durch Punkt getrennt, mit anzugeben, und er besteht
; aus drei Zeichen (siehe Anlage 6).
; Beispiel:
; SETRO MESSAGES.(F)

		header	SETRO,"SETRO",DOCOL

		dw wtoa
		dw LIT
		dw 25h
		dw drw
		dw DROP
		dw SEMIS

;------------------------------------------------------------------------------
; SETWR name ( -> )
;
; Setzen des Dateiattributes WR (write read) fr die Diskettendatei
; "name". Der Name darf maximal acht Zeichen lang sein. Der
; Dateityp ist, durch Punkt getrennt, mit anzugeben, und er besteht
; aus drei Zeichen (siehe Anlage 6).
; Beispiel:
; SETWR MESSAGES.(F)

		header	SETWR,"SETWR",DOCOL

		dw wtoa
		dw LIT
		dw 31h
		dw drw
		dw DROP
		dw SEMIS

;------------------------------------------------------------------------------
; ERA name ( -> )
;
; Lschen der Datei "name". Der Name darf maximal acht Zeichen lang
; sein. Der Dateityp ist, durch Punkt getrennt, mit anzugeben, und
; er besteht aus drei Zeichen (siehe Anlage 6).
; Beispiel:
; ERA MITTEIL.(F)

		header	ERA,"ERA",DOCOL

		dw wtoa
		dw LIT
		dw 11h
		dw drw
		dw DROP
		dw SEMIS

;------------------------------------------------------------------------------
; REN namealt nameneu ( -> )
;
; Die Datei mit dem Namen "namealt" wird in die Datei "nameneu"
; umbenannt. Die Namen drfen maximal acht Zeichen lang sein. Der
; Dateityp ist, durch Punkt getrennt, mit anzugeben, und er besteht
; aus drei Zeichen (siehe Anlage 6).
; Beispiel:
; REN MESSAGES.(F) MITTEIL.(F)

		header	REN,"REN",DOCOL

		dw wtoa
		dw LIT
		dw 29h
		dw drw
		dw DROP
		dw wtoa
		dw LIT
		dw 21h
		dw drw
		dw DROP
		dw SEMIS

;------------------------------------------------------------------------------
; fscrwr (n -> )
;
; Schreiben des Screens n als ersten Screen einer Datei auf Diskette.

		header	fscrwr,"fscrwr",DOCOL

		dw TOR
		dw THREE
		dw THREE
		dw THREE
		dw LIT
		dw 0Bh
		dw FROMR
		dw swr
		dw SEMIS

;------------------------------------------------------------------------------
; scrwr (n -> )
;
; Schreiben des Screens n einer Datei auf Diskette.

		header	scrwr,"scrwr",DOCOL

		dw TOR
		dw THREE
		dw THREE
		dw THREE
		dw THREE
		dw FROMR
		dw swr
		dw SEMIS

;------------------------------------------------------------------------------
; lscrwr ( n-> )
;
; Schreiben des Screens n als letzten Screen einer Datei auf Diskette.

		header	lscrwr,"lscrwr",DOCOL

		dw scrwr
		dw LIT
		dw 43h
		dw drw
		dw DROP
		dw SEMIS

;------------------------------------------------------------------------------
; fscrrd (n -> )
;
; Lesen des Screens n als ersten Screen einer Datei von Diskette.

		header	fscrrd,"fscrrd",DOCOL

		dw BLOCK
		dw btom
		dw TOR
		dw ONE
		dw ONE
		dw ONE
		dw FROMR
		dw THREE
		dw srd
		dw SEMIS

;------------------------------------------------------------------------------
; scrrd (n -> )
;
; Lesen des Screens n einer Datei von Diskette.

		header	scrrd,"scrrd",DOCOL

		dw BLOCK
		dw TOR
		dw ONE
		dw ONE
		dw ONE
		dw ONE
		dw FROMR
		dw LIT
		dw 4
		dw srd
		dw SEMIS

;------------------------------------------------------------------------------
; lscrwr ( n-> )
;
; Lesen des Screens n als letzten Screen einer Datei von Diskette.

		header	lscrrd,"lscrrd",DOCOL

		dw scrrd
		dw LIT
		dw 41h
		dw drw
		dw DROP
		dw SEMIS

;------------------------------------------------------------------------------
; DSAVE name (n1 n2 -> )
;
; Schreiben einer kompletten Datei auf Diskette. Die Datei enthlt
; die Screens n1 bis einschlielich n2 und wird unter dem Namen
; "name" gespeichert. Der Name kann maximal acht Zeichen lang sein.
; Als Dateikennzeichen wird (F) angehangen.
; Das Wort DSAVE arbeitet wie das Wort CSAVE des Moduls M026 (siehe
; Abschnitt 4.3. des FORTH-Handbuches).

		header	DSAVE,"DSAVE",DOCOL

		dw ftoa
		dw TDUP
		dw SUBB
		dw ZBRAN
		dw 32h
		dw TDUP
		dw SWAP
		dw ONEP
		dw SUBB
		dw ZBRAN
		dw 1Ch
		dw OVER
		dw fscrwr
		dw DUPP
		dw ROT
		dw ONEP
		dw XDO
		dw IDO
		dw scrwr
		dw XLOOP
		dw 0FFFAh
		dw lscrwr
		dw BRAN
		dw 8
		dw SWAP
		dw fscrwr
		dw lscrwr
		dw BRAN
		dw 0Eh
		dw fscrwr
		dw LIT
		dw 43h
		dw drw
		dw DROP
		dw DROP
		dw SEMIS

;------------------------------------------------------------------------------
; DLOAD name (n1 n2 -> )
;
; Laden der Datei "name" in die Screens n1 bis maximal n2. Der Name
; kann maximal acht Zeichen lang sein. Als Dateikennzeichen wird
; (F) angehangen. Ist die Datei krzer als die angegebenen Screens,
; wird folgende die Fehlermeldung ausgegeben:
; 81 name? MSG #12
; Die Systemvariable OFFSET enthlt die Anzahl der Screens, die vom
; Dateianfang an ignoriert werden sollen.
; Das Wort DLOAD arbeitet wie das Wort CLOAD des Moduls M026 (siehe
; Abschnitt 4.3. des FORTH-Handbuches).

DLOAD_		header	DLOAD,"DLOAD",DOCOL

		dw ftoa
		dw LIT
		dw 9
		dw drw
		dw DROP
		dw OFSET
		dw AT
		dw DDUP
		dw ZBRAN
		dw 16h
		dw LIT
		dw 4
		dw STAR
		dw ZERO
		dw XDO
		dw ONE
		dw drw
		dw DROP
		dw XLOOP
		dw 0FFF8h
		dw TDUP
		dw SUBB
		dw ZBRAN
		dw 32h
		dw TDUP
		dw SWAP
		dw ONEP
		dw SUBB
		dw ZBRAN
		dw 1Ch
		dw OVER
		dw fscrrd
		dw DUPP
		dw ROT
		dw ONEP
		dw XDO
		dw IDO
		dw scrrd
		dw XLOOP
		dw 0FFFAh
		dw lscrrd
		dw BRAN
		dw 8
		dw SWAP
		dw fscrrd
		dw lscrrd
		dw BRAN
		dw 0Eh
		dw fscrrd
		dw LIT
		dw 41h
		dw drw
		dw DROP
		dw DROP
		dw SEMIS

;------------------------------------------------------------------------------

unk_6A2:	db    3
aBye:		db "BYE                              "

		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db  31h	; 1
		db  37h	; 7
		db  34h	; 4
		db  31h	; 1
		db  32h	; 2
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0
		db    0

;------------------------------------------------------------------------------
; Initialisierung

		;org 	6F0h

Start		ld	hl, (aForth)	; Test auf String 'FORTH'
		ld	de, 4F46h	; "FO"
		and	a		; Cy=0
		sbc	hl, de
		jr	z, Start4	; wenn gefunden
		ld	de, 0
		ld	a, 2		; Modul schalten
		ld	l, a		; SWITCH 2 0
		call	PV1
		db	MODU		; BASIC-ROM ausschalten
		ld	bc, 880h	; Modulsuche ab Steckplatz 8
Start1:		in	a, (c)
		cp	0FBh		; Softwaremodul?
		jr	z, Start3	; Softwaremodul gefunden
Start2:		ld	a, 4		; 4 Steckplaetze weiter
		add	a, b
		ld	b, a
		jr	nc, Start1	; alle Steckplaetze testen
		call	PV1
		db	OSTR
		db	"THERE IS NO FORTH",0Ah,0Dh,0
		call	PV1
		db	LOOPP		; zurueck zu CAOS
;
Start3:		ld	a, 2
		ld	l, b		; Steckplatz
		ld	e, 0C1h		; Steuerbyte zum Einschalten auf C0000h
		ld	d, e
		push	bc
		call	PV1
                db	MODU		; Modul einschalten
                pop     bc
		ld	hl, (aForth)	; Test auf String 'FORTH'
		ld	de, 4F46h	; "FO"
		and	a		; Cy=0
		sbc	hl, de
		jr	z, Start4	;  wenn gefunden
		push	bc
		ld	de, 0		; wenn nicht gefunden, dann Modul
		ld	a, 2		; wieder ausschalten
		ld	l, b
		call	PV1
		db	MODU
		pop	bc
		jr	Start2		; und weitersuchen...

; FORTH ist vorhanden
Start4:		ld	hl, 0		; Ab Adresse 0 koennte Kommando FLOAD
		ld	b, 128		; stehen. Da dieser Speicherbereich
Start5:		ld	a, (hl)		; von FORTH anderweitig benoetigt wird, 
		cp	7Fh		; wird das Menuewort durch Entfernen
		jr	z, Start6	; der Prologbytes geloescht...
		inc	hl
		djnz	Start5
		jr	Start7
Start6:		ld	(hl), 0		; Prologbyte hier entfernen
Start7:		ld	hl, (INTAB)
Start8:		ld	(off_248), hl
		jp	jpwrm		; JP WRM

;------------------------------------------------------------------------------

		db    0
		db    0
		db  22h	; "
		db  84h	; 
		db 0B7h	; 
		db 0F5h	; 
		db 0CDh	; -
		db    3
		db 0F0h	; 
		db  35h	; 5
		db  3Eh	; >
		db  0Fh
		db 0CDh	; -
		db    3
		db 0F0h	; 
		db  14h
		db  3Eh	; >

		end
		
